# frozen_string_literal: true

Core.class_eval do
  def self.send_to_ui(channel, data, async: true)
    message = {:channel => channel, :data => data, :ext => {:auth_token => FAYE_TOKEN}}.to_json
    url = (Rails.env != "production") ? "#{APP_CONFIG['faye_domain']}/faye" : "https://#{APP_CONFIG["app_host"]}/faye"
    #Rails.logger.debug message.to_s
    if Rails.env != "production"
      RestClient.post(url, {'message' => message})
    else
      send_message = proc do
        begin
          response = RestClient::Request.execute(:url => url, :payload => {'message': message}, :method => :post, :verify_ssl =>  APP_CONFIG["unsecure"].blank?, :proxy => nil)
          Rails.logger.info "message sent to '#{channel}' : #{response.code}"
          Rails.logger.info JSON.parse(response.body) if (response.code != 200)
        rescue => e
          raise e unless async
          if channel.start_with?("/users")
            # RtJob.perform_later(url, message)
          else
            Rails.logger.info "Connexion RT error"
            false
          end
        end
      end

      return Thread.new(&send_message) if async
      send_message.call
    end
  rescue
    Rails.logger.info "Connexion RT error"
    false
  end
end