require 'csv'
raise 'You need to load this script througth a require' unless __FILE__
# Replace following variables if need
FILE_TYPE = 'csv'
FILE_PATH = "."
def run_script(skip)
  start_time = Time.now
  formated_t = start_time.strftime('%d-%m-%Y-%H:%M')
  puts "Start script at #{start_time}"
  file_name   = "#{HERMES_CONFIG['environment']}-#{formated_t}-#{__FILE__.split('/').last.gsub('.rb', ".#{FILE_TYPE}")}"
  file_class  = FILE_TYPE == 'csv' ? CSV : File
  file        = file_class.open("#{FILE_PATH}/#{file_name}", 'ab')
  ##############################################################################
  ##################################__SCRIPT__##################################
  # write the content of the script bellow

  ##################génération des indexs
  Hermes::ApplicantLink.index({housing_request_id: 1, applicant_ids: 1}, {background:true})
  Hermes::ApplicantLink.create_indexes
  ##################script a proprement parler 
  file << [
    "date",
    "applicant_id",
    "notified_offers_count",
    "total_notif_send_for_day"
  ]
  offset =365
 365.times do |i|  
  ap "day" +i.to_s
  total_notif_send_for_day = 0
  start = DateTime.now - (i+1+offset).days
  stop = DateTime.now - (i+offset).days
    begin
      notification_nb = 0
      offer_querry = {
        reserved: false,
        offer_status:"LOGEMENT PUBLIE",
        lessor_status: "PUBLIE",
        date_publication_start: {:$gte=> start, :$lte=>stop}}
      housing_offers = Hermes::HousingOffer.where(offer_querry)
      request_ids = []
      housing_offers.batch_size(5).each_with_index do |ho, j|
        query = ho.formated_eligibility.merge(is_active: true, active_application_id: nil, :request_status.in => ['ELIGIBLE', 'COMPLETE'])
        request_ids = request_ids + Hermes::HousingRequest.where(query).pluck(:id).map(&:to_s)
        request_ids = request_ids.uniq
      end
      request_ids.each do |hr_id|
        if hr = Hermes::HousingRequest.find(hr_id)
          hr_offers = hr.eligibles_offers.where(offer_querry).order_by(date_publication_start: :desc).limit(6).pluck(:id).map(&:to_s)
          unless hr_offers.count == 0
            total_notif_send_for_day= total_notif_send_for_day+1
            notification_nb += 1
          end
        end 
        line = [
          stop,
          hr.main_applicant.id.to_s,
          hr_offers.count ,
          total_notif_send_for_day
        ]
        file << line
        puts "#{notification_nb} notifications Sent "
        puts line.join(', ')
      end 
    rescue Exception => e
      line = ["Erreur de traitement : #{e}"]
      file << [line]
      puts line.join(', ')
    end
  end

  
  ##############################################################################
  ##############################################################################
  file.close
  stop_time = Time.now
  puts "Start end at #{stop_time}"
  puts "Executed in #{(stop_time - start_time).seconds}"
end
run_script( 0)