def resolve_active_activation_id_faillure(csv_output_path)
  require 'csv'
  output_data = [{
                   housing_application_id: "housing_application_id]&.id&.to_s",
                   housing_application_updated_at: "housing_application&.updated_at&.to_s",
                   housing_request_id: "housing_request_id&.id&.to_s",
                   first_name: "housing_request&.name&.to_s",
                   last_name: "housing_request&.name&.to_s",
                   als_id: "housing_request&.name&.to_s",
                   application_status: "application_status",
                   application_is_active: "housing_application&.is_active&.to_s",
                   error: "false si pas d'erreur"
                 }]
  housing_requests = Hermes::HousingRequest.where({is_active: true, active_application_id: {:$ne => nil}})
  total = housing_requests.length.to_s
  housing_requests.batch_size(5).each_with_index do |hr, i|
    begin
      housing_application = Hermes::HousingApplication.find(hr.active_application_id)
      if !housing_application.is_active 
        active_activation_id_error = {
          housing_application_id: housing_application&.id&.to_s,
          housing_application_updated_at: housing_application&.updated_at&.to_s,
          housing_request_id: hr&.id&.to_s, 
          first_name: hr&.requester_firstname ,
          last_name: hr&.requester_lastname,
          als_id: hr&.als_id,
          application_status: housing_application&.status&.to_s,
          application_is_active: housing_application&.is_active&.to_s,
          error: false
        }
        
        hr.active_application_id = nil
        hr.save
        output_data.push( active_activation_id_error)
        ap  active_activation_id_error
      
      end
      ap i.to_s + " / " + total.to_s
    rescue Exception => e
      ap e
      output_data.push({
                         housing_application_id: nil,
                         housing_application_updated_at: nil,
                         housing_request_id: nil,
                         first_name: nil ,
                         last_name: nil,
                         als_id: nil,
                         application_status: nil,
                         application_is_active: nil,
                         error: e.to_s
                       })
    end
  end
  return if output_data.length == 0
  ap "=============="
  ap "nombre de cas en erreur traités"
  ap output_data.length
  ap "=============="
  CSV.open(csv_output_path, "wb") do |csv|
    csv << output_data.first.keys # adds the attributes name on the first line
    output_data.each do |hash|
      csv << hash.values
    end
  end
end

resolve_active_activation_id_faillure("/home/webapp/output_resolve_active_activation_id_faillure.csv")