require 'rails_helper'
require [Hermes::Engine.root, %w[lib hermes tools specs]].flatten.join('/')

describe ::Api::D1::DocsController, type: :api do
  include Devise::Test::ControllerHelpers
  let!(:admin) { FactoryBot.create(:administrator) }

  describe 'POST /api/d1/docs' do
    it 'is blocked' do 
      authenticated_header(request, admin)
      get 'create'
      expect(response).to have_http_status(401)
    end 
  end 
end 

describe ::Api::D2::DocsController, type: :api do
  include Devise::Test::ControllerHelpers
  let!(:admin) { FactoryBot.create(:administrator) }

  describe 'POST /api/d2/docs' do
    it 'is blocked' do 
      authenticated_header(request, admin)
      get 'create'
      expect(response).to have_http_status(401)
    end 
  end 
end 
